#!/usr/local/bin/python
# -*- coding: UTF-8 -*-
# Copyright 2005, Søren Thing Pedersen stp@things.dk, Licensed under LGPL
# Modified by : Dhananjay Navaneetham "mb.dhananjay at gmail.com"

'''
     Creates a plugin for autocorrect in openoffice from a data file
'''

import os, sys, zipfile, zlib,csv
import header
from optparse import OptionParser


def zip_dir_into_file(dir, file):
    zfobj = zipfile.ZipFile(file, 'w', zipfile.ZIP_DEFLATED)
    for root, dirs, files in os.walk(dir):
        for thisfile in files:
            # print os.path.join(root,thisfile)
            zfobj.write(os.path.join(root, thisfile), os.path.join(root, thisfile).replace(dir, "")[1:])
    zfobj.close()


parser = OptionParser(usage="Usage: %prog -i <database file>", version='0.2')
parser.add_option('-i', '--input', dest='documentFile', default='DocumentList.csv', help='Specifies database file, default: [%default]',
                  action = 'store')
parser.add_option('-s', '--separator',dest='separator', default=' ',help='Specifies the delimiter, Default: [space]',
                  action = 'store')
#parser.add_option('-n', '--no-install', dest='install', help='Disable the install', action='store_true')
parser.add_option('-l','--language', dest='language', default='ml-IN', help='Specify the language', action='store')

(opts, args) = parser.parse_args()
DocumentList = opts.documentFile


class calc(csv.Dialect):
    delimiter = opts.separator
    quotechar = '"'
    doublequote = False
    quoting = csv.QUOTE_ALL
    escapechar = '\\'
    skipinitialspace = True
    lineterminator = '\r\n'
    
if True:
    destinationfile = "acorr_"+opts.language+".dat"

    tempdir = destinationfile + '_tmp'
    
    if (os.path.exis(destinationFile)):
        os.remove(destinationFile)
        
    if not (os.path.exists(tempdir)):
        os.mkdir(tempdir, 0777)

    if not (os.path.exists(tempdir + '/META-INF/')):
        os.mkdir(tempdir + '/META-INF/')
        
    manifestfile = open(os.path.join(tempdir + '/META-INF/', 'manifest.xml'), 'wb')
    manifestfile.write(header.manifest)
    manifestfile.close()

    mimetypefile = open(os.path.join(tempdir, 'mimetype'), 'wb')
    mimetypefile.write('')
    mimetypefile.close()

    DocumentListFile = open(os.path.join(tempdir, 'DocumentList.xml'), 'wb')
    DocumentListFile.write(header.fileheader + "\n")


    csvreader = csv.reader(file(DocumentList), calc)
    
    for row in csvreader:
        line = '  <block-list:block block-list:abbreviated-name="' + row[0] + '" block-list:name="' + row[1] + '"/>' + "\n";
        DocumentListFile.write(line)
    
    DocumentListFile.write(header.filefooter + "\n")
    DocumentListFile.close()

    zip_dir_into_file(tempdir, destinationfile)
    os.rmdir(tempdir)
    

    
